diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/adeos.c linux-2.6.6-ia64-adeos/arch/ia64/kernel/adeos.c
--- linux-2.6.6-ia64/arch/ia64/kernel/adeos.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/adeos.c	2004-06-17 11:46:40.000000000 +0200
@@ -0,0 +1,661 @@
+/*
+ *   linux/arch/ia64/kernel/adeos.c
+ *
+ *   Copyright (C) 2002,2003,2004 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ *   Architecture-dependent ADEOS core support for ia64.
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/smp.h>
+#include <linux/sched.h>
+#include <linux/irq.h>
+#include <linux/slab.h>
+#include <asm/system.h>
+#include <asm/atomic.h>
+#include <asm/hw_irq.h>
+#include <asm/delay.h>
+#include <asm/irq.h>
+#include <asm/unistd.h>
+
+void __adeos_switch_domain(adomain_t *adp,
+			   int cpuid);
+
+extern spinlock_t __adeos_pipelock;
+
+struct pt_regs __adeos_tick_regs;
+
+int __adeos_tick_irq;
+
+int adp_pipelined = 0;
+
+volatile unsigned long __adeos_itm_next[ADEOS_NR_CPUS];
+
+volatile unsigned long __adeos_itm_delta[ADEOS_NR_CPUS];
+
+/* Regardless of what asm-ia64/bitops.h says, ia64_fls() actually
+   returns the last bit _set_ and not cleared in a 64-bit quantity. */
+#define flnz(w) ia64_fls(w)
+
+#ifdef CONFIG_SMP
+
+static volatile unsigned long __adeos_cpu_sync_map;
+
+static volatile unsigned long __adeos_cpu_lock_map;
+
+static spinlock_t __adeos_cpu_barrier = SPIN_LOCK_UNLOCKED;
+
+static atomic_t __adeos_critical_count = ATOMIC_INIT(0);
+
+static void (*__adeos_cpu_sync)(void);
+
+void __adeos_send_IPI_allbutself (int vector)
+
+{
+    int cpu, nr_cpus = num_online_cpus();
+    adeos_declare_cpuid;
+
+    adeos_load_cpuid();
+
+    for (cpu = 0; cpu < nr_cpus; cpu++)
+	if (cpu_online(cpu) && cpu != cpuid)
+	    platform_send_ipi(cpu,vector,IA64_IPI_DM_INT,0);
+}
+
+void __adeos_send_IPI_other (int cpu, int vector) {
+
+    platform_send_ipi(cpu,vector,IA64_IPI_DM_INT,0);
+}
+
+static void __adeos_do_critical_sync (unsigned irq)
+
+{
+    adeos_declare_cpuid;
+    unsigned long flags;
+
+    adeos_lock_cpu(flags);
+
+    set_bit(cpuid,&__adeos_cpu_sync_map);
+
+    /* Now we are in sync with the lock requestor running on another
+       CPU. Enter a spinning wait until he releases the global
+       lock. */
+    adeos_spin_lock(&__adeos_cpu_barrier);
+
+    /* Got it. Now get out. */
+
+    if (__adeos_cpu_sync)
+	/* Call the sync routine if any. */
+	__adeos_cpu_sync();
+
+    adeos_spin_unlock(&__adeos_cpu_barrier);
+
+    clear_bit(cpuid,&__adeos_cpu_sync_map);
+
+    adeos_unlock_cpu(flags);
+}
+
+#endif /* CONFIG_SMP */
+
+/* adeos_critical_enter() -- Grab the superlock excluding all CPUs
+   but the current one from a critical section. This lock is used when
+   we must enforce a global critical section for a single CPU in a
+   possibly SMP system whichever context the CPUs are running
+   (i.e. interrupt handler or regular thread). */
+
+unsigned long adeos_critical_enter (void (*syncfn)(void))
+
+{
+    unsigned long flags;
+
+    adeos_hw_local_irq_save(flags);
+
+#ifdef CONFIG_SMP
+    if (num_online_cpus() > 1) /* We might be running a SMP-kernel on a UP box... */
+	{
+	adeos_declare_cpuid;
+
+	adeos_load_cpuid();
+
+	if (!test_and_set_bit(cpuid,&__adeos_cpu_lock_map))
+	    {
+	    while (test_and_set_bit(BITS_PER_LONG - 1,&__adeos_cpu_lock_map))
+		{
+		int n = 0;
+		do { cpu_relax(); } while (++n < cpuid);
+		}
+
+	    adeos_spin_lock(&__adeos_cpu_barrier);
+
+	    __adeos_cpu_sync = syncfn;
+
+	    /* Send the sync IPI to all processors but the current one. */
+	    __adeos_send_IPI_allbutself(ADEOS_CRITICAL_VECTOR);
+
+	    while (__adeos_cpu_sync_map != (cpu_online_map & ~__adeos_cpu_lock_map))
+		cpu_relax();
+	    }
+
+	atomic_inc(&__adeos_critical_count);
+	}
+#endif /* CONFIG_SMP */
+
+    return flags;
+}
+
+/* adeos_critical_exit() -- Release the superlock. */
+
+void adeos_critical_exit (unsigned long flags)
+
+{
+#ifdef CONFIG_SMP
+    if (num_online_cpus() > 1) /* We might be running a SMP-kernel on a UP box... */
+	{
+	adeos_declare_cpuid;
+
+	adeos_load_cpuid();
+
+	if (atomic_dec_and_test(&__adeos_critical_count))
+	    {
+	    adeos_spin_unlock(&__adeos_cpu_barrier);
+
+	    while (__adeos_cpu_sync_map != 0)
+		cpu_relax();
+
+	    clear_bit(cpuid,&__adeos_cpu_lock_map);
+	    clear_bit(BITS_PER_LONG - 1,&__adeos_cpu_lock_map);
+	    }
+	}
+#endif /* CONFIG_SMP */
+
+    adeos_hw_local_irq_restore(flags);
+}
+
+int __adeos_acknowledge_irq (unsigned irq) {
+
+    return 1;
+}
+
+void __adeos_init_stage (adomain_t *adp)
+
+{
+    int cpuid, n;
+
+    for (cpuid = 0; cpuid < ADEOS_NR_CPUS; cpuid++)
+	{
+	adp->cpudata[cpuid].irq_pending_hi = 0;
+
+	for (n = 0; n < IPIPE_IRQ_IWORDS; n++)
+	    adp->cpudata[cpuid].irq_pending_lo[n] = 0;
+
+	for (n = 0; n < IPIPE_NR_IRQS; n++)
+	    adp->cpudata[cpuid].irq_hits[n] = 0;
+	}
+
+    for (n = 0; n < IPIPE_NR_IRQS; n++)
+	{
+	adp->irqs[n].acknowledge = NULL;
+	adp->irqs[n].handler = NULL;
+	adp->irqs[n].control = IPIPE_PASS_MASK;	/* Pass but don't handle */
+	}
+
+#ifdef CONFIG_SMP
+    adp->irqs[ADEOS_CRITICAL_IPI].acknowledge = (int (*)(unsigned))&__adeos_acknowledge_irq;
+    adp->irqs[ADEOS_CRITICAL_IPI].handler = &__adeos_do_critical_sync;
+    /* Immediately handle in the current domain but *never* pass */
+    adp->irqs[ADEOS_CRITICAL_IPI].control = IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK|IPIPE_SYSTEM_MASK;
+#endif /* CONFIG_SMP */
+}
+
+/* __adeos_sync_stage() -- Flush the pending IRQs for the current
+   domain (and processor).  This routine flushes the interrupt log
+   (see "Optimistic interrupt protection" from D. Stodolsky et al. for
+   more on the deferred interrupt scheme). Every interrupt that
+   occurred while the pipeline was stalled gets played.  WARNING:
+   callers on SMP boxen should always check for CPU migration on
+   return of this routine. One can control the kind of interrupts
+   which are going to be sync'ed using the syncmask
+   parameter. IPIPE_IRQMASK_ANY plays them all, IPIPE_IRQMASK_VIRT
+   plays virtual interrupts only. */
+
+asmlinkage void __adeos_sync_stage (unsigned long syncmask)
+
+{
+    unsigned long mask, submask, flags;
+    struct adcpudata *cpudata;
+    adeos_declare_cpuid;
+    int level, rank;
+    adomain_t *adp;
+    unsigned irq;
+
+    adeos_lock_cpu(flags);
+
+    adp = adp_cpu_current[cpuid];
+    cpudata = &adp->cpudata[cpuid];
+
+    do
+	{
+	if (unlikely(test_and_set_bit(IPIPE_SYNC_FLAG,&cpudata->status)))
+	    goto release_cpu_and_exit;
+
+	/* The policy here is to keep the dispatching code
+	   interrupt-free by stalling the current stage. If the upper
+	   domain handler (which we call) wants to re-enable
+	   interrupts while in a safe portion of the code
+	   (e.g. SA_INTERRUPT flag unset for Linux's sigaction()), it
+	   will have to unstall (then stall again before returning to
+	   us!) the stage when it sees fit. */
+
+	while ((mask = (cpudata->irq_pending_hi & syncmask)) != 0)
+	    {
+	    /* Give a slight priority advantage to high-numbered IRQs
+	       like the virtual ones. */
+	    level = flnz(mask);
+	    clear_bit(level,&cpudata->irq_pending_hi);
+
+	    while ((submask = cpudata->irq_pending_lo[level]) != 0)
+		{
+		rank = flnz(submask);
+		irq = (level << IPIPE_IRQ_ISHIFT) + rank;
+
+		if (unlikely(test_bit(IPIPE_LOCK_FLAG,&adp->irqs[irq].control)))
+		    {
+		    clear_bit(rank,&cpudata->irq_pending_lo[level]);
+		    continue;
+		    }
+
+		if (likely(--cpudata->irq_hits[irq] == 0))
+		    clear_bit(rank,&cpudata->irq_pending_lo[level]);
+
+		/* Allow the sync routine to be reentered on behalf of
+		   the IRQ handler and any execution context switched
+		   in by the IRQ handler. The latter also means that
+		   returning from the switched out context is always
+		   safe even if the sync routine has been reentered in
+		   the meantime. */
+
+		set_bit(IPIPE_STALL_FLAG,&cpudata->status);
+
+		clear_bit(IPIPE_SYNC_FLAG,&cpudata->status);
+
+		adeos_unlock_cpu(flags);
+
+		adeos_hw_sti();
+
+		/* IPIPE_CALLASM_FLAG is dummy for this arch. */
+
+ 		if (adp == adp_root)
+		    {
+		    struct pt_regs regs;
+		    ia64_psr(&regs)->cpl = 0; /* For process times, implies CPL=0, kernel mode */
+		    void (*handler)(unsigned, struct pt_regs *) = (__typeof(handler))adp->irqs[irq].handler;
+		    handler(irq,&regs);
+		    }
+		else
+		    adp->irqs[irq].handler(irq);
+
+		adeos_lock_cpu(flags);
+
+#ifdef CONFIG_SMP
+		adeos_load_cpuid();
+		cpudata = &adp->cpudata[cpuid];
+#endif /* CONFIG_SMP */
+
+		clear_bit(IPIPE_STALL_FLAG,&cpudata->status);
+
+		if (test_and_set_bit(IPIPE_SYNC_FLAG,&cpudata->status))
+		    goto release_cpu_and_exit;
+		}
+	    }
+
+	clear_bit(IPIPE_SYNC_FLAG,&cpudata->status);
+	}
+    while ((cpudata->irq_pending_hi & syncmask) != 0);
+
+release_cpu_and_exit:
+
+    adeos_unlock_cpu(flags);
+}
+
+static inline void __adeos_walk_pipeline (struct list_head *pos, int cpuid)
+
+{
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *_adp = list_entry(pos,adomain_t,p_link);
+
+	if (test_bit(IPIPE_STALL_FLAG,&_adp->cpudata[cpuid].status))
+	    break; /* Stalled stage -- do not go further. */
+
+	if (_adp->cpudata[cpuid].irq_pending_hi != 0)
+	    {
+	    /* Since the critical IPI might be serviced by the
+	       following actions, the current domain might not be
+	       linked to the pipeline anymore after its handler
+	       returns on SMP boxes, even if the domain remains valid
+	       (see adeos_unregister_domain()), so don't make any
+	       hazardous assumptions here. */
+
+	    if (_adp == adp_cpu_current[cpuid])
+		__adeos_sync_stage(IPIPE_IRQMASK_ANY);
+	    else
+		{
+		__adeos_switch_to(_adp,cpuid);
+
+		adeos_load_cpuid(); /* Processor might have changed. */
+
+		if (!test_bit(IPIPE_STALL_FLAG,&adp_cpu_current[cpuid]->cpudata[cpuid].status) &&
+		    adp_cpu_current[cpuid]->cpudata[cpuid].irq_pending_hi != 0)
+		    __adeos_sync_stage(IPIPE_IRQMASK_ANY);
+		}
+
+	    break;
+	    }
+	else if (_adp == adp_cpu_current[cpuid])
+	    break;
+
+	pos = _adp->p_link.next;
+	}
+}
+
+void __adeos_handle_irq (long irq, struct pt_regs *regs)
+
+{
+    struct list_head *head, *pos;
+    adeos_declare_cpuid;
+    int m_ack, s_ack;
+
+    adeos_load_cpuid();
+
+    if (irq < 0)
+	{
+	m_ack = s_ack = 1;
+        irq = -irq;
+	}
+    else
+	m_ack = s_ack = 0;
+
+    if (unlikely(test_bit(IPIPE_STICKY_FLAG,&adp_cpu_current[cpuid]->irqs[irq].control)))
+	head = &adp_cpu_current[cpuid]->p_link;
+    else
+	head = __adeos_pipeline.next;
+
+    /* Ack the interrupt. */
+
+    pos = head;
+
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *_adp = list_entry(pos,adomain_t,p_link);
+
+	/* For each domain handling the incoming IRQ, mark it as
+           pending in its log. */
+
+	if (test_bit(IPIPE_HANDLE_FLAG,&_adp->irqs[irq].control))
+	    {
+	    /* Domains that handle this IRQ are polled for
+	       acknowledging it by decreasing priority order. The
+	       interrupt must be made pending _first_ in the domain's
+	       status flags before the PIC is unlocked. */
+
+	    _adp->cpudata[cpuid].irq_hits[irq]++;
+	    __adeos_set_irq_bit(_adp,cpuid,irq);
+
+	    /* Always get the first master acknowledge available. Once
+	       we've got it, allow slave acknowledge handlers to run
+	       (until one of them stops us). */
+
+	    if (!m_ack)
+		m_ack = _adp->irqs[irq].acknowledge(irq);
+	    else if (test_bit(IPIPE_SHARED_FLAG,&_adp->irqs[irq].control) && !s_ack)
+		s_ack = _adp->irqs[irq].acknowledge(irq);
+	    }
+
+	/* If the domain does not want the IRQ to be passed down the
+	   interrupt pipe, exit the loop now. */
+
+	if (!test_bit(IPIPE_PASS_FLAG,&_adp->irqs[irq].control))
+	    break;
+
+	pos = _adp->p_link.next;
+	}
+
+    if (likely(irq == __adeos_tick_irq))
+	{
+	unsigned long new_itm = __adeos_itm_next[cpuid];
+
+	do
+	    {
+	    new_itm += __adeos_itm_delta[cpuid];
+	    ia64_set_itm(new_itm);
+	    }
+	while (time_after_eq(ia64_get_itc(),new_itm));
+
+	__adeos_itm_next[cpuid] = new_itm;
+
+	__adeos_tick_regs.cr_iip = regs->cr_iip;
+	__adeos_tick_regs.cr_ipsr = regs->cr_ipsr;
+	__adeos_tick_regs.pr = regs->pr;
+	}
+
+    /* Now walk the pipeline, yielding control to the highest priority
+       domain that has pending interrupt(s) or immediately to the
+       current domain if the interrupt has been marked as
+       'sticky'. This search does not go beyond the current domain in
+       the pipeline. To understand this code properly, one must keep
+       in mind that domains having a higher priority than the current
+       one are sleeping on the adeos_suspend_domain() service. In
+       addition, domains having a lower priority have been preempted
+       by an interrupt dispatched to a more prioritary domain. Once
+       the first and most prioritary stage has been selected here, the
+       subsequent stages will be activated in turn when each visited
+       domain calls adeos_suspend_domain() to wake up its neighbour
+       down the pipeline. */
+
+    __adeos_walk_pipeline(head,cpuid);
+
+    adeos_load_cpuid();
+}
+
+/* adeos_trigger_irq() -- Push the interrupt to the pipeline entry
+   just like if it has been actually received from a hw source. This
+   both works for real and virtual interrupts. This also means that
+   the current domain might be immediately preempted by a more
+   prioritary domain who happens to handle this interrupt. */
+
+int adeos_trigger_irq (unsigned irq)
+
+{
+    struct pt_regs regs;
+
+    if (irq >= IPIPE_NR_IRQS ||
+	(adeos_virtual_irq_p(irq) && !test_bit(irq - IPIPE_VIRQ_BASE,&__adeos_virtual_irq_map)))
+	return -EINVAL;
+
+    ia64_psr(&regs)->cpl = 0;	/* For process times, implies CPL=0, kernel mode */
+
+    __adeos_handle_irq(-((long)irq),&regs);
+
+    return 1;
+}
+
+/*
+ * __adeos_switch_to() -- Switch domain contexts. The current domain
+ * is switched out while the domain pointed by "adp" is switched
+ * in. The current cpu identifier which is always known from callers
+ * is also passed to save a few cycles.
+ * This code works out the following tasks:
+ * - save it's stack pointer,
+ * - load the incoming domain's stack pointer,
+ * - update the global domain descriptor pointer,
+ * - then finally activate the incoming domain context.
+ *
+ * SMP version also provides for safe CPU migration (i.e. the domain
+ * may be switched back in on behalf of a different CPU than the one
+ * which switched it out).
+ */
+
+void __adeos_switch_to (adomain_t *adp, int cpuid)
+
+{
+    unsigned long flags;
+
+    adeos_hw_local_irq_save(flags);
+    __adeos_switch_domain(adp,cpuid);
+    adeos_hw_local_irq_restore(flags);
+    
+#ifdef CONFIG_SMP
+    adeos_load_cpuid();
+#endif /* CONFIG_SMP */
+    
+    if (adp_cpu_current[cpuid]->dswitch != NULL)
+	adp_cpu_current[cpuid]->dswitch();
+}
+
+asmlinkage int __adeos_enter_syscall (unsigned long scnum,
+				      struct pt_regs *regs,
+				      unsigned long a1,
+				      unsigned long a2,
+				      unsigned long a3,
+				      unsigned long a4,
+				      unsigned long a5)
+{
+    unsigned long old_regs[6];
+    int s;
+
+/* FIXME: The following way of intercepting the syscall args is
+   terminally sick, and wrecks all the optimization done by the kernel
+   guys regarding handling of user args over the syscall routines. We
+   must check for the existence of syscall monitors in the low-level
+   handling code (ivt.S) at the very least, so that we don't uselessly
+   run this ugly code when none exists. Eeek... */
+
+    if (unlikely(__adeos_event_monitors[ADEOS_SYSCALL_PROLOGUE] == 0))
+	return 0;
+
+    old_regs[0] = regs->r15;
+    old_regs[1] = regs->r16;
+    old_regs[2] = regs->r17;
+    old_regs[3] = regs->r18;
+    old_regs[4] = regs->r19;
+    old_regs[5] = regs->r20;
+
+    regs->r15 = scnum;
+    s = __adeos_handle_event(ADEOS_SYSCALL_PROLOGUE,regs);
+
+    regs->r15 = old_regs[0];
+    regs->r16 = old_regs[1];
+    regs->r17 = old_regs[2];
+    regs->r18 = old_regs[3];
+    regs->r19 = old_regs[4];
+    regs->r20 = old_regs[5];
+
+    return s;
+}
+
+asmlinkage int __adeos_exit_syscall (void) {
+
+    if (unlikely(__adeos_event_monitors[ADEOS_SYSCALL_EPILOGUE] > 0))
+	return __adeos_handle_event(ADEOS_SYSCALL_EPILOGUE,NULL);
+
+    return 0;
+}
+
+#ifdef ADEOS_DEBUG
+
+unsigned long __adeos_mark_array[ADEOS_NR_CPUS][32];
+
+long __adeos_max_mark[ADEOS_NR_CPUS];
+
+void __adeos_set_mark (int id)
+
+{
+    adeos_declare_cpuid;
+    unsigned long flags;
+
+    if (id < 0 || id >= 32)
+	return;
+
+    adeos_get_cpu(flags);
+
+    if (id > __adeos_max_mark[cpuid])
+	__adeos_max_mark[cpuid] = id;
+    
+    adeos_hw_tsc(__adeos_mark_array[cpuid][id]);
+
+    adeos_put_cpu(flags);
+}
+
+void __adeos_dump_marks (void)
+
+{
+    unsigned long t, ns, cpufreq = adeos_cpu_freq();
+    int cpuid, id;
+    long nr_marks;
+
+    printk("ADEOS: DUMPING MARKS\n");
+
+    for (cpuid = 0; cpuid < ADEOS_NR_CPUS; cpuid++)
+	{
+	nr_marks =__adeos_max_mark[cpuid];
+
+	for (id = 1; id <= nr_marks; id++)
+	    {
+	    t = __adeos_mark_array[cpuid][id] - __adeos_mark_array[cpuid][id-1];
+	    ns = t * 1000000000LL / cpufreq;
+	    printk("[%d] M%d -> M%d = %lu ns\n",cpuid,id-1,id,ns);
+	    }
+	}
+
+    printk("====================\n");
+}
+
+void __adeos_clear_marks (void)
+
+{
+    int cpuid;
+
+    for (cpuid = 0; cpuid < ADEOS_NR_CPUS; cpuid++)
+	__adeos_max_mark[cpuid] = 0;
+}
+
+EXPORT_SYMBOL(__adeos_set_mark);
+EXPORT_SYMBOL(__adeos_dump_marks);
+EXPORT_SYMBOL(__adeos_clear_marks);
+
+#endif /* ADEOS_DEBUG */
+
+EXPORT_SYMBOL(__adeos_init_stage);
+EXPORT_SYMBOL(__adeos_sync_stage);
+EXPORT_SYMBOL(__adeos_acknowledge_irq);
+EXPORT_SYMBOL(__adeos_switch_to);
+EXPORT_SYMBOL(__adeos_handle_irq);
+EXPORT_SYMBOL(__adeos_tick_regs);
+EXPORT_SYMBOL(__adeos_tick_irq);
+EXPORT_SYMBOL(__adeos_fork_domain);
+EXPORT_SYMBOL(adp_pipelined);
+EXPORT_SYMBOL(adeos_critical_enter);
+EXPORT_SYMBOL(adeos_critical_exit);
+EXPORT_SYMBOL(adeos_trigger_irq);
+#ifdef CONFIG_SMP
+EXPORT_SYMBOL(__adeos_send_IPI_allbutself);
+EXPORT_SYMBOL(__adeos_send_IPI_other);
+EXPORT_SYMBOL(__adeos_set_irq_affinity);
+#endif /* CONFIG_SMP */
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/entry.S linux-2.6.6-ia64-adeos/arch/ia64/kernel/entry.S
--- linux-2.6.6-ia64/arch/ia64/kernel/entry.S	2004-06-13 12:55:53.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/entry.S	2004-06-17 11:45:44.000000000 +0200
@@ -226,6 +226,179 @@ GLOBAL_ENTRY(ia64_switch_to)
 	br.cond.sptk .done
 END(ia64_switch_to)
 
+#ifdef CONFIG_ADEOS_CORE
+
+GLOBAL_ENTRY(__adeos_switch_domain)
+	.prologue
+	alloc r16=ar.pfs,2,0,0,0
+	DO_SAVE_SWITCH_STACK
+	.body
+	movl r26=adp_cpu_current
+#ifdef CONFIG_SMP
+	shl in1=in1,3			// CPU slot offset = cpuid * sizeof(pointer)
+	;; 
+	add r26=r26,in1			// r26=&adp_cpu_current[cpuid]
+#endif /* CONFIG_SMP */
+	;; 
+	ld8 r27=[r26]		        // r27=adp_cpu_current[cpuid]
+	st8 [r26]=in0		        // adp_cpu_current[cpuid]=incoming_domain
+	mov r26=in0
+	;;
+	adds r26=8,r26			// stack ptr restore area from new desc
+	adds r27=8,r27			// stack ptr save area into old desc
+#ifdef CONFIG_SMP
+	;;
+	add r26=r26,in1			// adjust to CPU slot
+	add r27=r27,in1
+#endif /* CONFIG_SMP */
+	;;
+	st8 [r27]=sp			// save old stack ptr
+	ld8 sp=[r26]
+	;;
+	DO_LOAD_SWITCH_STACK
+#ifdef CONFIG_SMP
+	sync.i				// ensure "fc"s done by this CPU are visible on other CPUs
+#endif /* CONFIG_SMP */
+	br.ret.sptk.many rp		// branch to incoming domain's resume point
+END(__adeos_switch_domain)
+
+GLOBAL_ENTRY(__adeos_fork_domain)
+	.prologue
+	alloc r16=ar.pfs,1,8,0,8
+	.rotr v[2]			// declare our 2 aliases for rotating
+	adds sp=-16,sp
+	DO_SAVE_SWITCH_STACK
+	.body
+	;;
+	mov r18=in0		        // r18 = new_domain->esp[cpuid] (copy destination)
+	mov r19=IA64_SWITCH_STACK_SIZE-8
+	;;
+	shr r19=r19,3			// r19=(8-bytes word count)-1
+	adds r18=-8,r18			// simulate initial pre-decrementation of dest index
+	adds r20=IA64_SWITCH_STACK_SIZE+8,sp // r20=((struct switch_stack *)sp + 1) + 8-bytes padding
+	;; 
+	mov ar.lc=r19			// loop count in repeat/until fashion
+	mov ar.ec=2			// two pipeline stages are active when copying
+	mov pr.rot=1<<16		// use p16(=1) and p17(=0) for predicates
+	;;
+copy_domain_stack:
+(p16)	ld8 v[0]=[r20],-8
+(p17)	st8 [r18]=v[1],-8
+	br.ctop.dptk.few copy_domain_stack
+	;;
+	.restore sp
+	adds sp=IA64_SWITCH_STACK_SIZE+16,sp
+	mov ar.pfs=r16
+	br.ret.sptk.many rp
+END(__adeos_fork_domain)
+
+GLOBAL_ENTRY(__adeos_ret_from_intr)
+	/* We have just returned from ia64_handle_irq(). Clear pIFast
+	if we are expected to exit the interrupt context through the
+	regular Linux path, i.e. if we are running over the
+	non-stalled root domain. Otherwise, make sure that we will
+	take the fast IRQ return path (i.e. no pending work processed
+	after the IRQ has been handled). */
+	cmp.eq pIFast,p0=r8,r0
+	movl r14=.adeos_leave_kernel
+	;; 
+	mov rp=r14
+	br.ret.sptk.many rp
+END(__adeos_ret_from_intr)
+
+/*
+ * __adeos_catch_syscall:	Feed the Adeos pipeline with the syscall event.
+ *	The value returned by __adeos_enter_syscall() will be passed
+ *	unmodified to our caller.
+ *	If zero is returned,	the syscall is going to be executed as required.
+ *	Otherwise, the syscall will be silently dropped.
+ *
+ *		  r15: syscall number + 1024 (must be preserved)
+ *		  r20: &pt_regs
+ *
+ * FIXME: the current approach for intercepting syscalls over ia64 is utterly
+ * intrusive. It clearly adds a fair amount of overhead per syscall
+ * where the kernel guys took extreme care of reducing it. --rpm
+ */
+
+GLOBAL_ENTRY(__adeos_catch_syscall)
+	.prologue ASM_UNW_PRLG_RP|ASM_UNW_PRLG_PFS, ASM_UNW_PRLG_GRSAVE(8)
+	alloc loc1=ar.pfs,8,4,8,0
+	mov loc0=rp
+	.body
+	mov loc2=r15
+	mov loc3=b6
+	adds out0=-1024,r15
+	mov out1=r20
+        mov out2=in0
+        mov out3=in1
+        mov out4=in2
+        mov out5=in3
+        mov out6=in4
+        mov out7=in5
+        ;;
+	br.call.sptk.many rp=__adeos_enter_syscall
+	mov b6=loc3
+	mov r15=loc2
+	mov ar.pfs=loc1
+	mov rp=loc0
+	br.ret.sptk.many b6
+END(__adeos_catch_syscall)
+
+/*
+ * __adeos_ret_from_syscall: 
+ *	We branch here on the return path from each syscall so
+ *	that we can call the Adeos callout for syscall exit. A different
+ *	path is used when syscalls are traced (see ia64_trace_syscall).
+ *	This code has been lifted from ia64_leave_syscall.
+ */
+
+GLOBAL_ENTRY(__adeos_ret_from_syscall)
+	PT_REGS_UNWIND_INFO(0)
+	cmp.lt p6,p0=r8,r0			// syscall failed?
+	adds r2=PT(R8)+16,sp			// r2 = &pt_regs.r8
+	adds r3=PT(R10)+16,sp			// r3 = &pt_regs.r10
+	mov r10=0
+(p6)	br.cond.sptk .adeos_syscall_error	// syscall failed ->
+	;;					// avoid RAW on r10
+.adeos_save_retval:
+.mem.offset 0,0; st8.spill [r2]=r8		// store return value in slot for r8
+.mem.offset 8,0; st8.spill [r3]=r10		// clear error indication in slot for r10
+	br.call.sptk.many rp=__adeos_exit_syscall
+	/* If the exit callout wants us to bypass all the work usually
+	done when resuming in user-space from a syscall (r8 != 0),
+	just set pIFast before branching to the epilogue code. */
+	cmp.ne pIFast,p0=r8,r0
+	br.cond.sptk .adeos_leave_syscall
+
+.adeos_syscall_error:
+	ld8 r3=[r2]				// load pt_regs.r8
+	sub r9=0,r8				// negate return value to get errno value
+	;;
+	cmp.ne p6,p0=r3,r0			// is pt_regs.r8!=0?
+	adds r3=16,r2				// r3=&pt_regs.r10
+	;;
+(p6)	mov r10=-1
+(p6)	mov r8=r9
+	br.cond.sptk .adeos_save_retval
+END(__adeos_ret_from_syscall)
+
+/*
+ * __adeos_bypass_syscall: 
+ *	We branch here when some domain above Linux in the
+ *	pipeline intercepts and blocks the syscall.
+ */
+
+GLOBAL_ENTRY(__adeos_bypass_syscall)
+	PT_REGS_UNWIND_INFO(0)
+	adds r2=PT(R8)+16,sp	// r2 = &pt_regs.r8
+	;;
+	ld8 r8=[r2]		// load retval returned by domain
+	br.cond.sptk ia64_ret_from_syscall
+END(__adeos_bypass_syscall)
+
+#endif /* CONFIG_ADEOS_CORE */
+
 /*
  * Note that interrupts are enabled during save_switch_stack and load_switch_stack.  This
  * means that we may get an interrupt with "sp" pointing to the new kernel stack while
@@ -546,6 +719,11 @@ GLOBAL_ENTRY(ia64_trace_syscall)
 .strace_save_retval:
 .mem.offset 0,0; st8.spill [r2]=r8		// store return value in slot for r8
 .mem.offset 8,0; st8.spill [r3]=r10		// clear error indication in slot for r10
+#ifdef CONFIG_ADEOS_CORE
+	br.call.sptk.many rp=__adeos_exit_syscall
+	cmp.ne pIFast,p0=r8,r0
+(pIFast) br.cond.sptk .adeos_leave_syscall
+#endif /* CONFIG_ADEOS_CORE */
 	br.call.sptk.many rp=syscall_trace // give parent a chance to catch return value
 .ret3:	br.cond.sptk ia64_leave_syscall
 
@@ -658,6 +836,10 @@ END(ia64_ret_from_syscall)
  *	      ar.ssd: cleared
  */
 GLOBAL_ENTRY(ia64_leave_syscall)
+#ifdef CONFIG_ADEOS_CORE
+	cmp.ne pIFast,p0=r0,r0			// pIFast=0: regular exit from syscall
+.adeos_leave_syscall:
+#endif /* CONFIG_ADEOS_CORE */
 	PT_REGS_UNWIND_INFO(0)
 	/*
 	 * work.need_resched etc. mustn't get changed by this CPU before it returns to
@@ -694,8 +876,14 @@ GLOBAL_ENTRY(ia64_leave_syscall)
 	;;
 
 	mov.m ar.ccv=r0		// clear ar.ccv
+#ifdef CONFIG_ADEOS_CORE
+(pIFast) br.cond.spnt .adeos_skip_work
+#endif /* CONFIG_ADEOS_CORE */
 (p6)	cmp4.ne.unc p6,p0=r15, r0		// any special work pending?
 (p6)	br.cond.spnt .work_pending
+#ifdef CONFIG_ADEOS_CORE
+.adeos_skip_work:
+#endif /* CONFIG_ADEOS_CORE */
 	;;
 	// start restoring the state saved on the kernel stack (struct pt_regs):
 	ld8.fill r8=[r16],16
@@ -771,6 +959,10 @@ END(ia64_ret_from_ia32_execve_syscall)
 	// fall through
 #endif /* CONFIG_IA32_SUPPORT */
 GLOBAL_ENTRY(ia64_leave_kernel)
+#ifdef CONFIG_ADEOS_CORE
+	cmp.ne pIFast,p0=r0,r0			// pIFast=0: regular exit from interrupt
+.adeos_leave_kernel:
+#endif /* CONFIG_ADEOS_CORE */
 	PT_REGS_UNWIND_INFO(0)
 	/*
 	 * work.need_resched etc. mustn't get changed by this CPU before it returns to
@@ -818,7 +1010,13 @@ GLOBAL_ENTRY(ia64_leave_kernel)
 	;;
 	ld8 r29=[r2],16		// load b7
 	ld8 r30=[r3],16		// load ar.csd
+#ifdef CONFIG_ADEOS_CORE
+(pIFast)br.cond.sptk .adeos_fast_path
+(p6)	br.cond.spnt .work_pending
+.adeos_fast_path:	
+#else /* !CONFIG_ADEOS_CORE */
 (p6)	br.cond.spnt .work_pending
+#endif /* CONFIG_ADEOS_CORE */
 	;;
 	ld8 r31=[r2],16		// load ar.ssd
 	ld8.fill r8=[r3],16
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/entry.h linux-2.6.6-ia64-adeos/arch/ia64/kernel/entry.h
--- linux-2.6.6-ia64/arch/ia64/kernel/entry.h	2004-06-13 12:29:08.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/entry.h	2004-06-17 11:45:44.000000000 +0200
@@ -9,6 +9,9 @@
 #define pUStk		p3	/* will leave_{kernel,syscall} return to user-stacks? */
 #define pSys		p4	/* are we processing a (synchronous) system call? */
 #define pNonSys		p5	/* complement of pSys */
+#ifdef CONFIG_ADEOS_CORE
+#define pIFast    	p22	/* fast interrupt return path? */
+#endif /* CONFIG_ADEOS_CORE */
 
 #define PT(f)		(IA64_PT_REGS_##f##_OFFSET)
 #define SW(f)		(IA64_SWITCH_STACK_##f##_OFFSET)
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/ia64_ksyms.c linux-2.6.6-ia64-adeos/arch/ia64/kernel/ia64_ksyms.c
--- linux-2.6.6-ia64/arch/ia64/kernel/ia64_ksyms.c	2004-06-13 12:29:08.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/ia64_ksyms.c	2004-06-17 11:45:44.000000000 +0200
@@ -122,3 +122,20 @@ EXPORT_SYMBOL(ia64_spinlock_contention);
 #  endif
 # endif
 #endif
+
+#ifdef CONFIG_ADEOS_CORE
+/* The following are per-platform convenience exports which are needed
+   by some Adeos domains loaded as kernel modules. */
+extern struct tty_driver console_driver;
+EXPORT_SYMBOL(console_driver);
+extern void show_stack(struct task_struct *task, unsigned long *sp);
+EXPORT_SYMBOL(show_stack);
+#include <asm/hw_irq.h>
+EXPORT_SYMBOL(_irq_desc);
+extern void wrap_mmu_context(struct mm_struct *mm);
+EXPORT_SYMBOL(wrap_mmu_context);
+extern struct ia64_ctx ia64_ctx;
+EXPORT_SYMBOL(ia64_ctx);
+DECLARE_PER_CPU(u8,ia64_need_tlb_flush);
+EXPORT_SYMBOL(per_cpu__ia64_need_tlb_flush);
+#endif /* CONFIG_ADEOS_CORE */
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/iosapic.c linux-2.6.6-ia64-adeos/arch/ia64/kernel/iosapic.c
--- linux-2.6.6-ia64/arch/ia64/kernel/iosapic.c	2004-06-13 12:55:53.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/iosapic.c	2004-06-17 11:45:44.000000000 +0200
@@ -243,7 +243,11 @@ mask_irq (unsigned int irq)
 	if (rte_index < 0)
 		return;			/* not an IOSAPIC interrupt! */
 
+#ifdef CONFIG_ADEOS_CORE
+	adeos_spin_lock_irqsave(&iosapic_lock, flags);
+#else /* !CONFIG_ADEOS_CORE */
 	spin_lock_irqsave(&iosapic_lock, flags);
+#endif /* CONFIG_ADEOS_CORE */	
 	{
 		writel(IOSAPIC_RTE_LOW(rte_index), addr + IOSAPIC_REG_SELECT);
 
@@ -252,7 +256,11 @@ mask_irq (unsigned int irq)
 
 		writel(low32, addr + IOSAPIC_WINDOW);
 	}
+#ifdef CONFIG_ADEOS_CORE
+	adeos_spin_unlock_irqrestore(&iosapic_lock, flags);
+#else /* !CONFIG_ADEOS_CORE */
 	spin_unlock_irqrestore(&iosapic_lock, flags);
+#endif /* CONFIG_ADEOS_CORE */
 }
 
 static void
@@ -269,13 +277,21 @@ unmask_irq (unsigned int irq)
 	if (rte_index < 0)
 		return;			/* not an IOSAPIC interrupt! */
 
+#ifdef CONFIG_ADEOS_CORE
+	adeos_spin_lock_irqsave(&iosapic_lock, flags);
+#else /* !CONFIG_ADEOS_CORE */
 	spin_lock_irqsave(&iosapic_lock, flags);
+#endif /* CONFIG_ADEOS_CORE */	
 	{
 		writel(IOSAPIC_RTE_LOW(rte_index), addr + IOSAPIC_REG_SELECT);
 		low32 = iosapic_intr_info[vec].low32 &= ~IOSAPIC_MASK;
 		writel(low32, addr + IOSAPIC_WINDOW);
 	}
+#ifdef CONFIG_ADEOS_CORE
+	adeos_spin_unlock_irqrestore(&iosapic_lock, flags);
+#else /* !CONFIG_ADEOS_CORE */
 	spin_unlock_irqrestore(&iosapic_lock, flags);
+#endif /* CONFIG_ADEOS_CORE */
 }
 
 
@@ -309,7 +325,11 @@ iosapic_set_affinity (unsigned int irq, 
 	/* dest contains both id and eid */
 	high32 = dest << IOSAPIC_DEST_SHIFT;
 
+#ifdef CONFIG_ADEOS_CORE
+	adeos_spin_lock_irqsave(&iosapic_lock, flags);
+#else /* !CONFIG_ADEOS_CORE */
 	spin_lock_irqsave(&iosapic_lock, flags);
+#endif /* CONFIG_ADEOS_CORE */	
 	{
 		/* get current delivery mode by reading the low32 */
 		writel(IOSAPIC_RTE_LOW(rte_index), addr + IOSAPIC_REG_SELECT);
@@ -327,7 +347,12 @@ iosapic_set_affinity (unsigned int irq, 
 		writel(IOSAPIC_RTE_LOW(rte_index), addr + IOSAPIC_REG_SELECT);
 		writel(low32, addr + IOSAPIC_WINDOW);
 	}
+#ifdef CONFIG_ADEOS_CORE
+	adeos_spin_unlock_irqrestore(&iosapic_lock, flags);
+#else /* !CONFIG_ADEOS_CORE */
 	spin_unlock_irqrestore(&iosapic_lock, flags);
+#endif /* CONFIG_ADEOS_CORE */
+
 #endif
 }
 
